
package de.ivu.elect.presentation.stimmzettel.menu;

import java.util.Collections;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.stimmzettel.StimmzettelErfassungVerfuegbar;
import de.ivu.elect.presentation.stimmzettel.StimmzettelKopfdatumSearchView;

@Named(StimmzettelKopfdatumSearchMenuItemEntry.COMPONENT_NAME)
public class StimmzettelKopfdatumSearchMenuItemEntry extends AbstractMenuItemEntry {

  public static final String COMPONENT_NAME ="stimmzettelKopfdatumSearchMenuItemEntry";

  private static final long serialVersionUID = 1L;

  @Inject
  private transient StimmzettelErfassungVerfuegbar stimmzettelErfassungVerfuegbar;

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.STIMMZETTEL_KOPFDATUM_SEARCH);
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public boolean isDisabledInternal() {
    return !stimmzettelErfassungVerfuegbar.isStimmzettelErfassungVerfuegbar();
  }

  @Override
  public String getTargetViewId() {
    return StimmzettelKopfdatumSearchView.VIEW_ID;
  }


  @Override
  protected String getLabel() {
    return getMessage(getLabelKey());
  }

  @Override
  public String getLabelKey() {
    return "stimmzettel.kopfdatum.erfassen.menu.entry.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconSearch();
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return Collections.emptyList();
  }
}
